<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class ConsultingRequest extends FormRequest
{

    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(in_array(Auth::user()->role, ['super_admin', 'admin', 'sub_admin']))
        {
            return true;
        }

        if(Auth::user()->hasModule('consultings'))
        {
            return true;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $timeRegex = '/[0-9]{2}:[0-9]{2}/';
        if ($this->consultingDetail){
            $rules = [
                'urgent_image' => 'required',
                'appointment_image' => 'required',
            ];
        } else {
            $rules = [
                'consulting_date' => 'required|date|after_or_equal:'.date('Y-m-d'),
//            'consulting_time' => 'required|after_or_equal:'.date('H:i'),
                'consulting_time' => 'required|regex:'.$timeRegex,
                'price' => 'required|numeric|gt:0',
                'status' => 'required|in:0,1',
                'type' => 'required|in:urgent,appointment',
                'way' => 'required|in:phone,zoom,office',
            ];

        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {

        $field = metaFields('consultings');
        $local = getCurrentLocale();
        $attributes=[
            'consulting_date' => $field[$local]['consulting_date'] ?? __('consultings.consulting_date'),
            'consulting_time' => $field[$local]['consulting_time'] ?? __('consultings.consulting_time'),
            'price' => $field[$local]['price'] ?? __('consultings.price'),
            'status' => $field[$local]['status'] ?? __('consultings.status'),
            'type' => $field[$local]['type'] ?? __('consultings.type'),
            'way' => $field[$local]['way'] ?? __('consultings.way'),
            'urgent_image' => $field[$local]['urgent_image'] ?? __('consultings.urgent_image'),
            'appointment_image' => $field[$local]['appointment_image'] ?? __('consultings.appointment_image'),

        ];


        return $attributes;
    }


    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests

        if(Request::ajax()){
            $errors = $validator->errors()->first();
            throw new HttpResponseException(response()->json(['errors' => $errors]));
        } else {
            // Do the original action of the Form request class
            parent::failedValidation($validator);
        }
    }
}
